# Magia

## Description
Magia generates Synthesizable SystemVerilog in pythonic syntax.

It is a Domain Specific Language build on top Python. 
**BUT NOT** a High Level Synthesis (HLS) framework, which compile arbitrary Python code into HDL.

## Installation

```bash
pip install syn-magia
```

## Examples

```python
...
```

Refer the [Syntax Documentation](docs/syntax.md) for more details.  

## Code Generation

Magia generates Synthesizable SystemVerilog code with the following command:

```python
from magia import Module


# Define a module
class TopLevel(Module):
    def __init__(self, feature, size_, **kwargs):
        super().__init__(**kwargs)
        ...


# Specialize the module
top = TopLevel(feature="cached", size_=16, name="TopModule")

# Elaborate SystemVerilog code
result = Module.elaborate(top)

# Obtain SystemVerilog code
sv_code_of_top = result["TopModule"]

# Write SystemVerilog code of all modules to a file
with open("All.sv", "w") as f:
    f.write("\n".join(result.values()))

```